#include <chrono>
#include <exception>
#include <fstream>
#include<glad/glad.h>
#include<GLFW/glfw3.h>
#include <iostream>
#include <stdexcept>
#include <thread>

int main(){
    // 初始化GLFW
    if(glfwInit()==0){
        throw std::runtime_error("failed to init GLFW");
    }
    GLFWwindow *window = glfwCreateWindow(640,480,"Example",nullptr,nullptr);

    if(window==nullptr){
        glfwTerminate();
        throw std::runtime_error("GLFW failed to create window");
    }

    glfwMakeContextCurrent(window);//创建上下文

    if(gladLoadGL()==0){  //加载GL函数
        glfwTerminate();
        throw std::runtime_error("GLAD Load GL functions failed");
    }
    
    std::cout<<"OpenGL version:"<<glGetString(GL_VERSION)<<"\n";

    while(glfwWindowShouldClose(window)==false){
        std::this_thread::sleep_for(std::chrono::milliseconds(1000/60));
        glfwSwapBuffers(window);
        glfwPollEvents();
    }
    return 0;
}

#ifdef _MSC_VER 
#include<Windows.h>
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
    main();
}
#endif